/*
 * CD enabler
 *
 * By: YOKOTA Hiroshi
 *
 * This is just a *BAD* hack for Panasonic Let's note CD-ROM device.
 *
 * Usage:
 *  disable CD-ROM device:
 *    1. install ACPI "bay" device driver.
 *    2. type "echo foo > /sys/devices/platform/bay.0/eject" to disable device.
 *
 *  enable CD-ROM device:
 *    1. compile this driver.
 *    2. use "insmod" command and load this driver to enable device.
 *    3. remove this driver
 */

#include <acpi/acpi_bus.h>
#include <acpi/acpi_drivers.h>
#include <asm/uaccess.h>
#include <linux/ctype.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/types.h>
#include <linux/version.h>

#define ACPI_FUNCTION_TRACE(x) {}
#define return_VALUE(x) return(x)
#define return_VOID return
#define acpi_driver_data(d) ((d)->driver_data)

#define LOGPREFIX "pcc_acpi_cd: "

static int __init acpi_pcc_cd_init(void)
{
	ACPI_FUNCTION_TRACE("acpi_pcc_cd_init");

	printk(KERN_INFO LOGPREFIX "loading...\n");

	if (acpi_disabled) {
		printk(KERN_INFO LOGPREFIX "ACPI disabled.\n");
		return_VALUE(-ENODEV);
	}

	acpi_evaluate_object(NULL, "\\_SB.FBAY", NULL, NULL); // setup
	acpi_evaluate_object(NULL, "\\_SB.CDEN", NULL, NULL); // enable (old method)
	acpi_evaluate_object(NULL, "\\_SB.DWAK", NULL, NULL); // enable (new method)

	return_VALUE(0);
}

static void __exit acpi_pcc_cd_exit(void)
{
	ACPI_FUNCTION_TRACE("acpi_pcc_cd_exit");

	printk(KERN_INFO LOGPREFIX "unloading...\n");

	return_VOID;
}

module_init(acpi_pcc_cd_init);
module_exit(acpi_pcc_cd_exit);
